;*******************(C) COPYRIGHT 2024 Masses-Chip ******************************
;* File Name          : M8P632_Touch_M1_Lib_CFG.ASM
;* Author             : MASSES CHIP
;* Version            : V3.05
;* Date               : 2024/10/29
;********************************************************************************
; 本文件用户不可自行修改

;================================================================================


;================================================================================ 
       
 LIST    p=m8P632

;================================================================================  
#include     m8P632.inc   
#include     M8R_P_MACRO.inc 
#include     M8P632_Touch_M1_Lib.inc
#include     M8P632_Touch_M1_Lib_CFG.INC   
 
;================================================================================  
 CODE 
 
;================================================================================        
#if TKLib_TouchLowerPower 
 ;FUNC 
 GLOBAL _WDT_WakeUp_Handle 
#endif 

 GLOBAL _ScanNextChannel 
 GLOBAL _TkSignalHandle_Next 
 
 extern TKCOM_PIN_OUT
 extern _READ_TK_EN_MASK_DATA 
 
; extern _READ_TAB_TOUCH_FN_DATA 
 
 extern TAB_TOUCH_FN_DATA 
 extern _RChannelEnL    
 extern _RChannelEnH  

 extern _RTkTemp9    
 extern _RTkTemp10 
#define RTkmaskL        _RTkTemp9
#define RTkmaskH        _RTkTemp10

 extern _RTkTemp2 
#define berror_F        _RTkTemp2,4 

 extern _RTkTemp4 
#define _R_CNT          _RTkTemp4


 extern _RTkBuff2 
#define RTk_CH            _RTkBuff2


 EXTERN     _RTkBitFlag 

;==================================================================== 
#if TKLib_TouchLowerPower
_WDT_WakeUp_Handle:
; Stack:	Level 1
; INPUT:	 
; OUTPUT:	
; OTHER	:
;此程序是在触摸低功耗模式下，需要处理的操作，如有需要可增加操作程序  
;如RTC时钟1S计时程序,LCD时钟刷新显示程序等等
  
  
  
  
; bclr  bLowPowerModeRun ; 可根据需求，判断系统是否需要强制唤醒(清bLowPowerModeRun，强制唤醒系统)
                         
    return 
#endif
 
;================================================================================   
;以下用户可不查看 
;================================================================================    
;==================================================================== 
_ScanNextChannel:
; Stack:	Level 3
; INPUT:	 
; OUTPUT:	
; OTHER	:	

    CALL    TKCOM_PIN_OUT 	

; set tk ch	
    clrr    TK1CHSL
    clrr    TK1CHSH  ;关闭所有连接的通道

#if EnTk16		
    jbts0   _RChannelEnL,0
    goto    scantk16_set
#endif

#if EnTk17	    
    jbts0   _RChannelEnL,1
    goto    scantk17_set
#endif

#if EnTk18	    
    jbts0   _RChannelEnL,2
    goto    scantk18_set
#endif

#if EnTk19	    
    jbts0   _RChannelEnL,3
    goto    scantk19_set
#endif

#if EnTk20	    
    jbts0   _RChannelEnL,4
    goto    scantk20_set
#endif

#if EnTk21	    
    jbts0   _RChannelEnL,5
    goto    scantk21_set
#endif

#if EnTk30	    
    jbts0   _RChannelEnH,6
    goto    scantk30_set
#endif

#if EnTk31	    
    jbts0   _RChannelEnH,7
    goto    scantk31_set
#endif

    bset    bOneScanDone
    CALL    _READ_TK_EN_MASK_DATA  
    goto    ScanNextChannel_end ;error	
    
#if EnTk16		
scantk16_set:
    bclr    _RChannelEnL,0	 
    bset    TK1CHSL,0  		
    goto    ScanNextChannel_end_1			
#endif

#if EnTk17		
scantk17_set:
    bclr    _RChannelEnL,1		 
    bset    TK1CHSL,1  		
    goto    ScanNextChannel_end_1	
#endif

#if EnTk18		 
scantk18_set:
    bclr    _RChannelEnL,2		 
    bset    TK1CHSL,2  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk19	
scantk19_set:
    bclr    _RChannelEnL,3	 
    bset    TK1CHSL,3  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk20			 
scantk20_set:
    bclr    _RChannelEnL,4	 
    bset    TK1CHSL,4  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk21		 
scantk21_set:
    bclr    _RChannelEnL,5	 
    bset    TK1CHSL,5  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk30		 
scantk30_set:
    bclr    _RChannelEnH,6	 
    bset    TK1CHSH,6  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk31		 
scantk31_set:
    bclr    _RChannelEnH,7	 
    bset    TK1CHSH,7  		
    goto    ScanNextChannel_end_1
#endif  
  
ScanNextChannel_end_1:
    incr    RTk_CH,r
	
ScanNextChannel_end:	
    CLRR    _R_CNT	
    return	
 
;==================================================================== 
_TkSignalHandle_Next: 
; Stack:	Level 2
; INPUT:	 
; OUTPUT:	
; OTHER	:

;read finger data
    clrr    RTkmaskL 
    clrr    RTkmaskH

    movia   high(TAB_TOUCH_FN_DATA)
    movar   FSR1
    movia   low(TAB_TOUCH_FN_DATA)
    movar   FSR0

   ;CALL _READ_TAB_TOUCH_FN_DATA 

#if EnTk16	 
    jbts0   _RChannelEnL,0
    goto    READ_tk16_FN
#endif

#if EnTk17    
    jbts0   _RChannelEnL,1
    goto    READ_tk17_FN
#endif

#if EnTk18    
    jbts0   _RChannelEnL,2
    goto    READ_tk18_FN
#endif

#if EnTk19    
    jbts0   _RChannelEnL,3
    goto    READ_tk19_FN
#endif

#if EnTk20    
    jbts0   _RChannelEnL,4
    goto    READ_tk20_FN
#endif

#if EnTk21    
    jbts0   _RChannelEnL,5
    goto    READ_tk21_FN
#endif

#if EnTk30    
    jbts0   _RChannelEnH,6
    goto    READ_tk30_FN    
#endif

#if EnTk31    
    jbts0   _RChannelEnH,7
    goto    READ_tk31_FN    
#endif

    bset    berror_F
    goto    READ_tkx_FN_end_1   ;error,no tk ch en 

#if EnTk16 
READ_tk16_FN:
    bset     RTkmaskL,0
    bclr     _RChannelEnL,0	 	
    goto     READ_tkx_FN_end_1			
#endif

#if EnTk17	
READ_tk17_FN:
    bset     RTkmaskL,1
    bclr     _RChannelEnL,1	 		
    goto     READ_tkx_FN_end_1	
#endif

#if EnTk18	 
READ_tk18_FN:
    bset     RTkmaskL,2 
    bclr     _RChannelEnL,2		 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk19
READ_tk19_FN:
    bset     RTkmaskL,3 
    bclr     _RChannelEnL,3	 	
    goto     READ_tkx_FN_end_1
#endif

#if EnTk20		 
READ_tk20_FN:
    bset     RTkmaskL,4 
    bclr     _RChannelEnL,4	 		
    goto     READ_tkx_FN_end_1
#endif

#if EnTk21	 
READ_tk21_FN:
    bset     RTkmaskL,5 
    bclr     _RChannelEnL,5	 	
    goto     READ_tkx_FN_end_1
#endif

#if EnTk30	 
READ_tk30_FN:
    bset     RTkmaskH,6 
    bclr     _RChannelEnH,6	 
    goto     READ_tkx_FN_end_1
#endif	

#if EnTk31	 
READ_tk31_FN:
    bset     RTkmaskH,7 
    bclr     _RChannelEnH,7	 
    goto     READ_tkx_FN_end_1
#endif
  
READ_tkx_FN_end_1:

    return

;================================================================================  
  end
  
;*********************************END OF FILE************************************

                                   