;*******************(C) COPYRIGHT 2024 Masses-Chip ******************************
;* File Name          : M8P632_Touch_M1_Lib_Data.INC
;* Author             : MASSES CHIP
;* Version            : V3.05
;* Date               : 2024/10/29
;********************************************************************************
; 本文件用户不可自行修改

;================================================================================ 
#include     M8P632_Touch_M1_Lib_CFG.INC 
;================================================================================ 
;触摸库RAM分配起始地址，不建议修改，或保证修改后有足够地址分配到触摸库使用
; RAM RTKLibGroup0 分配的起始地址 ~ 0xff 被触摸库中使用

RTKLibGroup0 udata (0xff+1-14-8-6-8*TKLib_M1_OPENED_TK_AMOUNT)  

;================================================================================
;14
_RTkTemp0        res        1
_RTkTemp1        res        1 
_RTkTemp2        res        1 
_RTkTemp3        res        1 
_RTkTemp4        res        1 
_RTkTemp5        res        1
_RTkTemp6        res        1          
_RTkTemp7        res        1         
_RTkTemp8        res        1         
_RTkTemp9        res        1        
_RTkTemp10       res        1        
_RTkTemp11       res        1          
_RTkTemp12       res        1  
_RTkTemp13       res        1 
;3
_RTkBuff2        res        1        
_RTkBuff4        res        1  
_RTkBuff5        res        1 

#if  TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff0       res        2*TKLib_M1_OPENED_TK_AMOUNT          
_RTkGBuff1       res        2*TKLib_M1_OPENED_TK_AMOUNT         
_RTkGBuff2       res        1*TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff3       res        1*TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff4       res        6
_RTkGBuff5       res        1*TKLib_M1_OPENED_TK_AMOUNT
_RTkGBuff6       res        1*TKLib_M1_OPENED_TK_AMOUNT

#endif

_RChannelEnL     res        1       
_RChannelEnH     res        1       
_RKeyOnFlgL      res        1        
_RKeyOnFlgH      res        1 
_RTkBitFlag      res        1  

;================================================================================  
; 程序区  ~ 0x0FEF，用户不可使用
;================================================================================ 
#if TKLib_TouchLowerPower
TAB_TOUCH_TKLP_CFG_DATA:

 org    (0x0FEF+1-2-12-TKLib_M1_OPENED_TK_AMOUNT-1)
 
TAB_TOUCH_TKLP_LP_SLEEPTIME:
 RETIA     (TKLib_LP_SLEEPTIME&0xff)

#endif
 
TAB_TOUCH_CFG_DATA:

 org    (0x0FEF+1-2-12-TKLib_M1_OPENED_TK_AMOUNT) 
         
TAB_TOUCH_TK_EN_MASK_L_DATA:
 RETIA     (TKLib_M1_TK_EN_MASK&0X00FF)
 
TAB_TOUCH_TK_EN_MASK_H_DATA:
 RETIA     (TKLib_M1_TK_EN_MASK>>8)

TAB_TOUCH_OPENED_TK_AMOUNT_DATA: 
 RETIA     (TKLib_M1_OPENED_TK_AMOUNT&0x0F) 

TAB_TOUCH_TKCKS_DATA:
 RETIA     ((TKLib_TKCKS&0x03)<<4)
 
TAB_TOUCH_NUM_DATA:  
 RETIA     (((TKLib_TOUCH_NUM&0x1F)<<0)+((0)<<6)+((TKLib_Multi_TOUCH_RST&0x01)<<7))

TAB_TOUCH_LONG_TOUCH_TIME:  
 RETIA     (TKLib_LONG_TOUCH_TIME&0x0F)

TAB_TOUCH_CONFIRM_TIME_DATA: 
 RETIA     ((TKLib_EFFECTIVE_TOUCH_TIME&0x0F)+((TKLib_INVALID_TOUCH_TIME&0x0F)<<4))

TAB_TOUCH_SCAN_DATA:
 RETIA     (TKLib_ScanCnt-1)

TAB_TOUCH_POWER_ON_DELAY_TIME:
 RETIA     (TKLib_PowerOn_Delay_Time&0xff)
 
TAB_TOUCH_BASELINE_UP_SPEED:
 RETIA		(TKLib_BaseLineUpSpeed&0x0f)
 
TAB_TOUCH_BASELINE_DOWN_SPEED:
 RETIA		(TKLib_BaseLineDownSpeed&0x0f)


TAB_TOUCH_FN_DATA:
#if EnTk16  
 DW     ((TKLib_TK16_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk17 
 DW     ((TKLib_TK17_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk18 
 DW     ((TKLib_TK18_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk19 
 DW     ((TKLib_TK19_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk20 
 DW     ((TKLib_TK20_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk21 
 DW     ((TKLib_TK21_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk30 
 DW     ((TKLib_TK30_F_THRESHOLD&0xff)<<8)
#endif

#if EnTk31 
 DW     ((TKLib_TK31_F_THRESHOLD&0xff)<<8)
#endif

 DW     (0x0309)
 
;================================================================================         
 ; RAM
 GLOBAL _RTkTemp0   
 GLOBAL _RTkTemp1   
 GLOBAL _RTkTemp2    
 GLOBAL _RTkTemp3   
 GLOBAL _RTkTemp4  
 GLOBAL _RTkTemp5      
 GLOBAL _RTkTemp6    
 GLOBAL _RTkTemp7    
 GLOBAL _RTkTemp8    
 GLOBAL _RTkTemp9    
 GLOBAL _RTkTemp10   
 GLOBAL _RTkTemp11     
 GLOBAL _RTkTemp12 
 GLOBAL _RTkTemp13 
 
 GLOBAL _RTkBitFlag     
 GLOBAL _RKeyOnFlgL   
 GLOBAL _RKeyOnFlgH   
 GLOBAL _RChannelEnL     
 GLOBAL _RChannelEnH 

 
 GLOBAL _RTkBuff2
 GLOBAL _RTkBuff4
 GLOBAL _RTkBuff5  

 GLOBAL _RTkGBuff0     
 GLOBAL _RTkGBuff1    
 GLOBAL _RTkGBuff2     
 GLOBAL _RTkGBuff3 
 GLOBAL _RTkGBuff4 
 GLOBAL _RTkGBuff5 
 GLOBAL _RTkGBuff6  
 ; CODE
 GLOBAL TAB_TOUCH_TK_EN_MASK_L_DATA 
 GLOBAL TAB_TOUCH_TK_EN_MASK_H_DATA 
 GLOBAL TAB_TOUCH_OPENED_TK_AMOUNT_DATA           
 GLOBAL TAB_TOUCH_TKCKS_DATA   
 GLOBAL TAB_TOUCH_NUM_DATA
 GLOBAL TAB_TOUCH_LONG_TOUCH_TIME
 GLOBAL TAB_TOUCH_CONFIRM_TIME_DATA
 GLOBAL	TAB_TOUCH_SCAN_DATA
 GLOBAL	TAB_TOUCH_POWER_ON_DELAY_TIME 
 GLOBAL	TAB_TOUCH_BASELINE_UP_SPEED
 GLOBAL	TAB_TOUCH_BASELINE_DOWN_SPEED
 GLOBAL TAB_TOUCH_FN_DATA 

#if TKLib_TouchLowerPower 
 ; CODE
 GLOBAL TAB_TOUCH_TKLP_LP_SLEEPTIME
#endif

;================================================================================
#ifndef __M8P632_Touch_M1_Lib_Build_Message_INC__
#define __M8P632_Touch_M1_Lib_Build_Message_INC__
;================================================================================
#if EnTk16
    MESSG "    TK16: Enable"  
#endif
#if EnTk17
    MESSG "    TK17: Enable"  
#endif
#if EnTk18
    MESSG "    TK18: Enable"  
#endif
#if EnTk19
    MESSG "    TK19: Enable"  
#endif
#if EnTk20
    MESSG "    TK20: Enable"  
#endif
#if EnTk21
    MESSG "    TK21: Enable"  
#endif
#if EnTk30
    MESSG "    TK30: Enable"  
#endif
#if EnTk31
    MESSG "    TK31: Enable"  
#endif

;================================================================================
#if (TKLib_M1_OPENED_TK_AMOUNT == 0)
    Error "    No channel is enabled,Please reconfigure EnTk0~EnTk10"  
#endif	

;================================================================================
;CDC Clock
#if (TKLib_TKCKS == 0)
    MESSG "    CDC1 Clock: Fosc/4"  
#endif
#if (TKLib_TKCKS == 1)
    MESSG "    CDC1 Clock: Fosc/8"  
#endif
#if (TKLib_TKCKS == 2)
    MESSG "    CDC1 Clock: Fosc/16"  
#endif
#if (TKLib_TKCKS == 3)
    MESSG "    CDC1 Clock: Fosc/32" 
#endif

;================================================================================
#if (TKLib_TOUCH_NUM == 0)
    Error "    Error: Please setting TKLib_TOUCH_NUM > 0"  
#endif

;================================================================================
#if (TKLib_LONG_TOUCH_TIME == 0)
    MESSG "    屏蔽按键最长输出时间功能，即触摸不离开，按键标志一直会置位 " 
#endif
#if (TKLib_LONG_TOUCH_TIME == 1)
    Error "    禁止配置 " 
#endif
#if (TKLib_LONG_TOUCH_TIME > 15)
    Error "    Error: Please setting TKLib_LONG_TOUCH_TIME <= 15"  
#else
#if (TKLib_LONG_TOUCH_TIME > 1)
    MESSG "    开启按键最长输出时间功能，若触摸不离开，按键标志会输出一段时间后，会清零 " 
#endif
#endif

;================================================================================
#if (TKLib_Multi_TOUCH_RST > 1)
    Error "    Error: Please setting TKLib_Multi_TOUCH_RST ∈ {0,1}  "  
#endif

;================================================================================

#if (TKLib_LongKeyBaseTime < 1)
    Error "    Error: Please setting TKLib_LongKeyBaseTime >= 1" 
#endif
#if (TKLib_LongKeyBaseTime > 254)
    Error "    Error: Please setting TKLib_LongKeyBaseTime <= 254"  
#endif

;================================================================================
#if (TKLib_EFFECTIVE_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME > 0"  
#endif
#if (TKLib_EFFECTIVE_TOUCH_TIME > 14)
    Error "    Error: Please setting TKLib_EFFECTIVE_TOUCH_TIME <= 14"  
#endif

;================================================================================
#if (TKLib_INVALID_TOUCH_TIME == 0)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME > 0"  
#endif
#if (TKLib_INVALID_TOUCH_TIME > 14)
    Error "    Error: Please setting TKLib_INVALID_TOUCH_TIME <= 14"  
#endif

;================================================================================
#if (TKLib_TK16_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK16_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK17_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK17_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK18_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK18_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK19_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK19_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK20_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK20_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK21_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK21_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK30_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK30_F_THRESHOLD <= 254"  
#endif
#if (TKLib_TK31_F_THRESHOLD > 254)
    Error "    Error: Please setting TKLib_TK31_F_THRESHOLD <= 254"  
#endif

;================================================================================
#if (TKLib_TK16_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK16_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK17_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK17_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK18_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK18_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK19_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK19_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK20_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK20_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK21_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK21_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK30_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK30_F_THRESHOLD >= 8"
#endif
#if (TKLib_TK31_F_THRESHOLD <8)
    Error "    Error: Please setting TKLib_TK31_F_THRESHOLD >= 8"
#endif

;================================================================================
#if (TKLib_TouchLowerPower==1)
    MESSG "    触摸低功耗模式：已开启 " 
#endif   
#if (TKLib_TouchLowerPower==0)
    MESSG "    触摸低功耗模式：未开启 "	
#endif
#if (TKLib_TouchLowerPower>1)
    MESSG "    触摸低功耗模式：配置错误，TKLib_TouchLowerPower ∈ {0,1} "	
#endif
;================================================================================
#if (TKLib_ScanCnt < 3 )
    Error "    Error: Please setting TKLib_ScanCnt >= 3"  
#endif
#if (TKLib_ScanCnt > 254)
    Error "    Error: Please setting TKLib_ScanCnt < 255"  
#endif
;================================================================================
#if (TKLib_PowerOn_Delay_Time < 0 )
    Error "    Error: Please setting TKLib_PowerOn_Delay_Time >= 0"  
#endif
#if (TKLib_PowerOn_Delay_Time > 254)
    Error "    Error: Please setting TKLib_PowerOn_Delay_Time < 255"  
#endif
;================================================================================
#if (TKLib_BaseLineUpSpeed < 1 )
    Error "    Error: Please setting TKLib_BaseLineUpSpeed >= 1"  
#endif
#if (TKLib_BaseLineUpSpeed > 14)
    Error "    Error: Please setting TKLib_BaseLineUpSpeed < 15"  
#endif
;================================================================================
#if (TKLib_BaseLineDownSpeed < 1 )
    Error "    Error: Please setting TKLib_BaseLineDownSpeed >= 1"  
#endif
#if (TKLib_BaseLineDownSpeed > 14)
    Error "    Error: Please setting TKLib_BaseLineDownSpeed < 15"  
#endif
;================================================================================
#endif

;*********************************END OF FILE************************************

                                   